/*
 * Copyright © 2012-2015, Intel Corporation. All rights reserved.
 * Please see the included README.md file for license terms and conditions.
 */


/*jslint browser:true, devel:true, white:true, vars:true */
/*global $:false, intel:false app:false, dev:false, cordova:false */



// This file contains your event handlers, the center of your application.
// NOTE: see app.initEvents() in init-app.js for event handler initialization code.

function myEventHandler() {
    "use strict" ;

    var ua = navigator.userAgent ;
    var str ;

    if( window.Cordova && dev.isDeviceReady.c_cordova_ready__ ) {
            str = "It worked! Cordova device ready detected at " + dev.isDeviceReady.c_cordova_ready__ + " milliseconds!" ;
    }
    else if( window.intel && intel.xdk && dev.isDeviceReady.d_xdk_ready______ ) {
            str = "It worked! Intel XDK device ready detected at " + dev.isDeviceReady.d_xdk_ready______ + " milliseconds!" ;
    }
    else {
        str = "Bad device ready, or none available because we're running in a browser." ;
    }

    alert(str) ;
}


// ...additional event handlers here...
//****************
var planet=['','Меркурии','Венере','Земле','Марсе','Юпитере','Сатурне','Уране','Нептуне'];
var age=[],bday=[],time=[],happy=[];
//var imgs=['imgs/mercury.jpg', ...]// if share with picture
function calcAge(str) {
            var period=[30, 87.969, 224.698, 365.2425, 686.98, 4332.589, 10759.22, 30685.4, 60190.03];//periods of planets 1st is sun
            
			//setlocal();
            var title,descr,bd_title;
           var is_2day=false;//today is bd on some planet
            var cltime=1e6,clothest=1;
            //var earth=false;
            
            //var str=document.getElementById('date').value;
			if (str == '') {alert('Введите дату рождения')} else { 
            var bd=new Date(str);
          
            var Jbd=getJD(bd);//jd of birth day
            var today=new Date();
            var today_str;
            today_str=today.getDate()+'.'+(today.getMonth()+1)+'.'+today.getFullYear();
              document.getElementById('dr').innerHTML="ваш день рождения: "+bd.getDate()+'.'+(bd.getMonth()+1)+'.'+bd.getFullYear();    
            var Jtoday=getJD(today);
               // alert(Jtoday+' '+JtoG(Jtoday));
            var ageInDays=Jtoday-Jbd;
            
            if (ageInDays<0) {alert('Неверная дата!')} 
			else { db.setItem("birth_date", str);
				for (var i=1; i<=8; i++)	{ 
						if (i==3) {
                        age[i]=today.getFullYear()-bd.getFullYear();
        
                        if ( bd.getMonth() > today.getMonth() ) {age[i]--;} else if ( (bd.getMonth() == today.getMonth()) && ( bd.getDate()>today.getDate() )) age[i]--;
                            happy[i]=bd.getDate()+'.'+(bd.getMonth()+1)+'.'+(bd.getFullYear()+age[i]);
                            var nextbd=bd;
							
                            nextbd.setFullYear(nextbd.getFullYear()+age[i]+1);
                            bday[i]= getJD(nextbd);//
                            //alert(JtoG(bday[i])+' '+nextbd.toDateString());
							time[i]=bday[i]-Jtoday;
                            //title='Мой возраст на Земле '+plural1(age[i]);
                            //descr='AstroAge';
                            document.getElementById('p'+i).innerHTML='<p>Ваш возраст '+plural1(age[i])+'</p>Следующий день рождения<br> '+nextbd.getDate()+'.'+(nextbd.getMonth()+1)+'.'+nextbd.getFullYear()+'<br>через '+pluralD(time[i])+'<br>';
                            //add event to calendar if checkbox
                            //if (document.getElementById('add2Cal').checked) toCal(age[3],nextbd.getFullYear()+'-'+(nextbd.getMonth()+1)+'-'+(nextbd.getDate()),nextbd.getFullYear()+'-'+(nextbd.getMonth()+1)+'-'+(nextbd.getDate()+1), planet[i]);
                          
                        } 
                    else {
                        age[i]=Math.floor(ageInDays/period[i]);
                        //if (i==1) alert(period[i]*(age[i]+1)+' '+ageInDays);
                        if ( (  period[i]*(age[i]+1) - ageInDays) <= 1.0 ) age[i]++;
				        bday[i]=Jbd+Math.floor(period[i]*(age[i]+1));
						time[i]=bday[i]-Jtoday;
                        var fmt='s';
                        var emt='';//ad2Cal(' при попытке передать планету через a href js:ad2Cal ( ...., марсе) он считал марсе функцией
                        var prm=age[i]+',  '+ JtoG(bday[i],fmt)+', '+ JtoG((bday[i]+1),fmt)+', '+ i;
						document.getElementById('p'+i).innerHTML='<p><a href="javascript:{shareButton('+age[i]+', '+i+')}">Ваш возраст '+plural1(age[i])+'<img src="imgs/share.png" class="little_share"/></a></p><a href="javascript:{ad2Cal(' + prm+');}">Следующий день рождения<br> '+JtoG(bday[i],emt)+'<br>через '+pluralD(time[i])+"</a>";
                        //title='Мой возраст на '+planet[i]+':'+plural1(age[i]);
                        //descr='AstroAge';
                        //когда был день рождения
                        happy[i]=JtoG(Math.floor(period[i]*(age[i]))+Jbd,'');
                         //add events to calendar if checkbox
                        if (document.getElementById('add2Cal').checked) {toCal( age[i], JtoG(bday[i],'m'), JtoG(bday[i]+1,'m'), i );

                         }
                    }
                    
                    //ближайший др 
                    if (!is_2day) if (time[i] < cltime) { clothest=i;cltime=time[i];}              
                    
                    title=plural1(age[i])+' на '+planet[i];
                    descr='#AstroAge #АстроВозраст';
                    var sb=document.getElementById('b'+i);
                     if  ( ( age[i]!=0 ) && ( happy[i]==today_str) ){//проверка сегодня на др
                     // sb.setAttribute("type","image");
                       //         sb.setAttribute("src","imgs/pie.gif");
                                //sb.setAttribute("value","center");
                         //       sb.setAttribute("class","pie");
                           //     sb.setAttribute("onclick","shareBD('"+title+"','"+descr+"')");
                         clothest=i;is_2day=true;bd_title=title;
                          
                     } else sb.setAttribute("onclick","shareButton("+age[i]+","+i+")");
                   
                }
               // alert(happy[1]+' '+happy[2]);
                 if (is_2day) shareBD(bd_title,descr);//поздравление
                
                        $(function() {
                        $('#fotorama').fotorama();
                            
                      });
               // alert(clothest,cltime);
		              document.body.removeChild(document.getElementById('input'));
					  document.getElementById('result').style.display = "block";
                if (clothest > 0) location.href="#"+clothest;
               
					  //document.getElementById('input').style.display = "none";
            }

            } //document.getElementById('p'+i).innerHTML='JD '+getJD(bd);
        }

            //function to write correct year years, day <> days
			function plural1(n) {var m=n%10, l=n%100; return n + ' ' + (((m==1)&&(l!=11))?'год':(((m==2)&&(l!=12)||(m==3)&&(l!=13)||(m==4)&&(l!=14))?'года':'лет'))}
			function pluralD(n) {var m=n%10, l=n%100; return n + ' ' + (((m==1)&&(l!=11))?'день':(((m==2)&&(l!=12)||(m==3)&&(l!=13)||(m==4)&&(l!=14))?'дня':'дней'))}
			
            //julian date to grigorian JtoG(julian date, [format])
            function JtoG(JD,fmt) {
                fmt = fmt || '';//так мы присваиваем пустую строку если fmt не задан
                var julDate = JD;
                var z = Math.floor(JD);
                var f = julDate - z;
                //alert(f);
                if (z < 2299161) {
                    var A = z;
                }
                else {
                    var omega = Math.floor((z-1867216.25)/36524.25);
                    var A = z + 1 + omega - Math.floor(omega/4);
                }
                var B = A + 1524;
                var C = Math.floor((B-122.1)/365.25);
                var D = Math.floor(365.25*C);
                var Epsilon = Math.floor((B-D)/30.6001);
                var dayGreg = B - D - Math.floor(30.6001*Epsilon) + f;
                if (Epsilon < 14) {
                    monthGreg = Epsilon - 1;
                }
                else {
                    monthGreg = Epsilon - 13;
                }
                if (monthGreg > 2) {
                    yearGreg = C - 4716;
                }
                else {
                    yearGreg = C - 4715;
                }
                var str=monthGreg+'/'+dayGreg+'/'+yearGreg;
                var time= new Date(str);
                var text=dayGreg+'.'+monthGreg+'.'+yearGreg;
                if (fmt=='m') text=str;//американский формат мм/дд/гггг
                if (fmt=='s') text=time.getTime();//вывод даты в милисекундах оэ эры юникс
                return text
	       }
        //get julian date
        function getJD(date) {
		    month = date.getMonth();
            _month = (month * 1) + 1;

            //month = 6;
            
            
            day = date.getDate();
            year = date.getFullYear();

            var i,d;
            d = 0;
            for (i=1859; i<=year-1; i++)
            {
            if  ((i/4-Math.floor(i/4)) == 0 )
             {d = Math.floor(d) + 366}
            else 
             {d = Math.floor(d) + 365};
            };

            for (i=1; i<=_month-1; i++)
            { 
            if ((i==1) || (i==3) || (i==5) || (i==7) || (i==8) || (i==10) || (i==12))
               {d = Math.floor(d) + 31};
            if ( (i==4) || (i==6) || (i==9) || (i==11) )
               {d = Math.floor(d) + 30};  
            if ( (i==2) )
               {if  ((i/4-Math.floor(i/4)) == 0 ) 
                {d = Math.floor(d) + 29}
                else
                {d = Math.floor(d) + 28};
               };       
            };
            var JD = Math.floor(d) + day + 2400044;//вычисляет неверно ошибка +0.5
		 
		 return JD
		 }
        // add event with confirmation
        function ad2Cal(age,Gdat,end,place) {
            //ad2cal(setup {)
            //var age=setup.age || 1
            //var Gdat=setup.start || "2016-01-01"
            //var end = setup.end || "2016-01-02"
            //var  place= setup.place || 3 // index of planet
            function onConfirm(buttonIndex) {
                //alert(planet[place]);
                if (buttonIndex==1) toCal(age,Gdat,end,place);
                if (buttonIndex==2) window.plugins.socialsharing.share('Мне будет '+plural1(age+1)+' на '+planet[place]+' ' +JtoG(bday[place])+', через '+pluralD(time[place]), '#' , null, "http://astrutil.zz.mu/astroage/",function(result){
                console.log('Success');
            }, function(result){
               console.log('Failure'); 
            });
            }
                //alert(age);
            navigator.notification.confirm(
                'Добавить напоминание в календарь или рассказать друзьям? ', // message
                 onConfirm,            // callback to invoke with index of button pressed
                plural1(age+1)+' на '+planet[place],           // title
                ['Добавить','Рассказать','Нет']     // buttonLabels
            );
        }
        //add  event to calendar silently
       function toCal(age,Gdat,end,place) {
        // prep some variables
          // alert(Gdat);
          var startDate = new Date(Gdat); // beware: month 0 = january, 11 = december
        //  alert(startDate);
           var endDate = new Date(end);
         //  alert(endDate);
          var title = (age+1)+"й день рождения";
          var location = "на "+planet[place];
          var notes = "сегодня мой "+(age+1)+"й день рождения "+location+". запусти #AstroAge для деталей";
        //var dat = new Date(). getTime();
          // var timeNot= new Date( dat + place * 3600000);
           //alert(timeNot);
    cordova.plugins.notification.local.schedule({
        id: place,
        title: title,
        text: notes,
        at: startDate
        //data: { meetingId:"#123FG8" }
    });
           //  var netu=false;
          var success = function(message) { //alert("Success: " + JSON.stringify(message)); 
                                            //if (place == 8) alert('Все напоминания добавлены'); 
                                              };
          var error = function(message) { //alert("Error: " + JSON.stringify(message));
                                        };
        //   window.plugins.calendar.findEvent(title,location,notes,startDate,endDate,success,error);
        window.plugins.calendar.createEvent(title,location,notes,startDate,endDate,success,error);
       }

            // Show the share dialog to user
            //****************
        function shareButton(age,place) {
                            
                            window.plugins.socialsharing.share('Мне '+plural1(age)+'  на '+planet[place],"#АстроВозраст",null,"http://astrutil.zz.mu/astroage/",function(result){
                console.log('Success');
            }, function(result){
               console.log('Failure'); 
            });
        }
// show alert about BD and ask for share
                function shareBD(title,descr) {
                        function onConfirm(buttonIndex) {
                            if (buttonIndex==2) window.plugins.socialsharing.share('Сегодня мне исполнилось '+title,descr,null,"http://astrutil.zz.mu/astroage/",function(result){
                            console.log('Success');
                        }, function(result){
                           console.log('Failure'); 
                        });
                        }

            navigator.notification.confirm(
                'Сегодня ваш день рождения: '+title, // message
                 onConfirm,            // callback to invoke with index of button pressed
                'Поздравляем!',           // title
                ['Спасибо','Рассказать друзьям']     // buttonLabels
            );
                            
        }
// share the app in Google play
        function social_share()
        {  
            //Parameters:
            //Message, Subject, File Path(relative, File URL or file://), URL, success callback, fail callback
            window.plugins.socialsharing.share("АстроВозраст - узнай сколько тебе лет на других планетах!","#AstroAge #АстроВозраст",'www/imgs/qr.jpg',"https://play.google.com/store/apps/details?id=com.mixxavgmail.com.AstroAgefree",function(result){
                console.log('Success');
            }, function(result){
                console.log('fail');
            });
        }
       
        function email_share()
        {  
            window.plugins.socialsharing.canShareViaEmail(function(){
                alert("Email client is configured");
            }, function(){
                alert("Email client is not configured");
            });
           //Parameters:
            //Body, Subject, Array of to address, Array of CC, Array of BCC, Array of attachments url(relative, File URL or file://), success callback, error callback
            window.plugins.socialsharing.shareViaEmail('Email Body','Subject',['to@person1.com', 'to@person2.com'],['cc@person1.com'],null,['https://www.google.nl/images/srpr/logo4w.png'],function(result){
                alert('result: ' + result);
            },function(result){
                alert('result: ' + result);
            });
        }
       
        function sms_share()
        {
            window.plugins.socialsharing.shareViaSMS('Message', '1223221312,8172645367');
        }
    function alertDismissed() {
    // do something
	}
    
function relocate(hr) {
	document.location.href = hr;
}

    function changeLocale(lng) {
        alert(lng);
        if (lng == 'en') document.location.href="indexru.html";
        if (lng == 'ru') relocate("index.html");
    }
function showNotif() {    
//cordova.plugins.notification.local.on("schedule", function(notification) {
//    alert("scheduled: " + notification.id);
//});
//    cordova.plugins.notification.local.isPresent(7, function (present) {
//    alert(present ? "present 7" : "not found 7");
//});
//    cordova.plugins.notification.local.isPresent(8, function (present) {
//    alert(present ? "present 8" : "not found 8");
//});
    //alert(cordova.plugins.notification.local);
    cordova.plugins.notification.local.getScheduledIds(function (ids) {
     alert('Scheduled IDs: ' + ids.join(' ,'));// getScheduledIds() or getTriggeredIds()
});
    //window.plugin.notification.local.getScheduledIds(function (scheduledIds) {
//     alert('Scheduled IDs: ' + scheduledIds.join(' ,'));
//});
}